<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>IoInterfaceFile Class Reference</title>
<link href="xsens.css" rel="stylesheet" type="text/css"/>
</head><body>
<img class="logo" src="xsenslogo.jpg" alt="Xsens Logo" />
	<!-- Generated by Doxygen 1.8.11 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="class_io_interface_file-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">IoInterfaceFile Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>The low-level file communication class.  
 <a href="class_io_interface_file.html#details">More...</a></p>
<div class="dynheader">
Inheritance diagram for IoInterfaceFile:</div>
<div class="dyncontent">
<div class="center"><img src="class_io_interface_file__inherit__graph.png" border="0" usemap="#_io_interface_file_inherit__map" alt="Inheritance graph"/></div>
<map name="_io_interface_file_inherit__map" id="_io_interface_file_inherit__map">
<area shape="rect" id="node2" href="struct_io_interface.html" title="An abstract IO interface. " alt="" coords="15,5,96,32"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:afe61a877361812e624a4dd8b4fb60fa2"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#afe61a877361812e624a4dd8b4fb60fa2">IoInterfaceFile</a> ()</td></tr>
<tr class="separator:afe61a877361812e624a4dd8b4fb60fa2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa0fae8ef051e708aa3658add2808c780"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#aa0fae8ef051e708aa3658add2808c780">~IoInterfaceFile</a> ()</td></tr>
<tr class="separator:aa0fae8ef051e708aa3658add2808c780"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a83fce965ce5bc30b9f8e58057d9abc7c"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#a83fce965ce5bc30b9f8e58057d9abc7c">close</a> () override</td></tr>
<tr class="memdesc:a83fce965ce5bc30b9f8e58057d9abc7c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Close the file, overrides <a class="el" href="struct_io_interface.html#a3256915d0f4056dec116d500c9c2382c" title="Close the connection to the device. ">IoInterface::close()</a>.  <a href="#a83fce965ce5bc30b9f8e58057d9abc7c">More...</a><br /></td></tr>
<tr class="separator:a83fce965ce5bc30b9f8e58057d9abc7c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac740d713c17c0635271b26d2decc7383"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#ac740d713c17c0635271b26d2decc7383">closeFile</a> ()</td></tr>
<tr class="memdesc:ac740d713c17c0635271b26d2decc7383"><td class="mdescLeft">&#160;</td><td class="mdescRight">Close the file.  <a href="#ac740d713c17c0635271b26d2decc7383">More...</a><br /></td></tr>
<tr class="separator:ac740d713c17c0635271b26d2decc7383"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aecc40c56361c0cf28e70545d6cc78ca2"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#aecc40c56361c0cf28e70545d6cc78ca2">flushData</a> () override</td></tr>
<tr class="memdesc:aecc40c56361c0cf28e70545d6cc78ca2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Flush all data in the buffers to and from the device.  <a href="#aecc40c56361c0cf28e70545d6cc78ca2">More...</a><br /></td></tr>
<tr class="separator:aecc40c56361c0cf28e70545d6cc78ca2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab66936abe77dc38fd58da68c984ad60d"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#ab66936abe77dc38fd58da68c984ad60d">isOpen</a> () const  override</td></tr>
<tr class="memdesc:ab66936abe77dc38fd58da68c984ad60d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return whether the file is open or not.  <a href="#ab66936abe77dc38fd58da68c984ad60d">More...</a><br /></td></tr>
<tr class="separator:ab66936abe77dc38fd58da68c984ad60d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa3eaa5e537ea2cc4c8d9d81c9b705955"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#aa3eaa5e537ea2cc4c8d9d81c9b705955">getLastResult</a> () const  override</td></tr>
<tr class="memdesc:aa3eaa5e537ea2cc4c8d9d81c9b705955"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the result code of the last operation.  <a href="#aa3eaa5e537ea2cc4c8d9d81c9b705955">More...</a><br /></td></tr>
<tr class="separator:aa3eaa5e537ea2cc4c8d9d81c9b705955"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a358b75e4c84de5e7fc533033c21b4c79"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#a358b75e4c84de5e7fc533033c21b4c79">writeData</a> (const <a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;data, XsSize *written=nullptr) override</td></tr>
<tr class="memdesc:a358b75e4c84de5e7fc533033c21b4c79"><td class="mdescLeft">&#160;</td><td class="mdescRight">Write the data contained in <em>data</em> to the device.  <a href="#a358b75e4c84de5e7fc533033c21b4c79">More...</a><br /></td></tr>
<tr class="separator:a358b75e4c84de5e7fc533033c21b4c79"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2d4e1496bc2c478c726f297e8dd078c7"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#a2d4e1496bc2c478c726f297e8dd078c7">readData</a> (XsSize maxLength, <a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;data) override</td></tr>
<tr class="memdesc:a2d4e1496bc2c478c726f297e8dd078c7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read at most <em>maxLength</em> bytes from the device into <em>data</em>.  <a href="#a2d4e1496bc2c478c726f297e8dd078c7">More...</a><br /></td></tr>
<tr class="separator:a2d4e1496bc2c478c726f297e8dd078c7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ade44b56b10040f5cb6e6b97a17076c19"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#ade44b56b10040f5cb6e6b97a17076c19">readTerminatedData</a> (XsSize maxLength, unsigned char terminator, <a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;bdata)</td></tr>
<tr class="memdesc:ade44b56b10040f5cb6e6b97a17076c19"><td class="mdescLeft">&#160;</td><td class="mdescRight">Read data from the file and put it into the data buffer.  <a href="#ade44b56b10040f5cb6e6b97a17076c19">More...</a><br /></td></tr>
<tr class="separator:ade44b56b10040f5cb6e6b97a17076c19"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a02f006131b80872d2425b0cc9fad445f"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#a02f006131b80872d2425b0cc9fad445f">appendData</a> (const <a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;bdata)</td></tr>
<tr class="memdesc:a02f006131b80872d2425b0cc9fad445f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Write data to the end of the file.  <a href="#a02f006131b80872d2425b0cc9fad445f">More...</a><br /></td></tr>
<tr class="separator:a02f006131b80872d2425b0cc9fad445f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1856f74bcaf06c2e826237b68fa6d781"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#a1856f74bcaf06c2e826237b68fa6d781">closeAndDelete</a> ()</td></tr>
<tr class="memdesc:a1856f74bcaf06c2e826237b68fa6d781"><td class="mdescLeft">&#160;</td><td class="mdescRight">Close the file and delete it.  <a href="#a1856f74bcaf06c2e826237b68fa6d781">More...</a><br /></td></tr>
<tr class="separator:a1856f74bcaf06c2e826237b68fa6d781"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a90ebe248517cdd233e270704a4a51c8e"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#a90ebe248517cdd233e270704a4a51c8e">create</a> (const <a class="el" href="struct_xs_string.html">XsString</a> &amp;filename)</td></tr>
<tr class="memdesc:a90ebe248517cdd233e270704a4a51c8e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Create an empty file.  <a href="#a90ebe248517cdd233e270704a4a51c8e">More...</a><br /></td></tr>
<tr class="separator:a90ebe248517cdd233e270704a4a51c8e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1073cd5d38d4590e0e2953af7f5f8c44"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#a1073cd5d38d4590e0e2953af7f5f8c44">deleteData</a> (<a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a> start, XsSize length)</td></tr>
<tr class="memdesc:a1073cd5d38d4590e0e2953af7f5f8c44"><td class="mdescLeft">&#160;</td><td class="mdescRight">Delete the given data from the file.  <a href="#a1073cd5d38d4590e0e2953af7f5f8c44">More...</a><br /></td></tr>
<tr class="separator:a1073cd5d38d4590e0e2953af7f5f8c44"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac238d2c4d69f981009b0db4bf9fbb9f2"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#ac238d2c4d69f981009b0db4bf9fbb9f2">find</a> (const <a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;data, <a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a> &amp;pos)</td></tr>
<tr class="memdesc:ac238d2c4d69f981009b0db4bf9fbb9f2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Find a string of bytes in the file.  <a href="#ac238d2c4d69f981009b0db4bf9fbb9f2">More...</a><br /></td></tr>
<tr class="separator:ac238d2c4d69f981009b0db4bf9fbb9f2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afd93d17ccecb4859a08569d10692db94"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#afd93d17ccecb4859a08569d10692db94">getFileSize</a> () const </td></tr>
<tr class="memdesc:afd93d17ccecb4859a08569d10692db94"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the size of the file.  <a href="#afd93d17ccecb4859a08569d10692db94">More...</a><br /></td></tr>
<tr class="separator:afd93d17ccecb4859a08569d10692db94"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a28c28fbac8993d2eeea459ed0f3ddc90"><td class="memItemLeft" align="right" valign="top"><a class="el" href="struct_xs_time_stamp.html">XsTimeStamp</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#a28c28fbac8993d2eeea459ed0f3ddc90">getFileDate</a> () const </td></tr>
<tr class="memdesc:a28c28fbac8993d2eeea459ed0f3ddc90"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the creation date of the file.  <a href="#a28c28fbac8993d2eeea459ed0f3ddc90">More...</a><br /></td></tr>
<tr class="separator:a28c28fbac8993d2eeea459ed0f3ddc90"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a809280e635cbdb2a928577f706ac95af"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#a809280e635cbdb2a928577f706ac95af">getName</a> (<a class="el" href="struct_xs_string.html">XsString</a> &amp;filename) const </td></tr>
<tr class="memdesc:a809280e635cbdb2a928577f706ac95af"><td class="mdescLeft">&#160;</td><td class="mdescRight">Retrieve the filename that was last successfully opened.  <a href="#a809280e635cbdb2a928577f706ac95af">More...</a><br /></td></tr>
<tr class="separator:a809280e635cbdb2a928577f706ac95af"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad4e42b0d2b33c3fd58355061404f3089"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad4e42b0d2b33c3fd58355061404f3089"></a>
<a class="el" href="struct_xs_string.html">XsString</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#ad4e42b0d2b33c3fd58355061404f3089">getFileName</a> () const </td></tr>
<tr class="memdesc:ad4e42b0d2b33c3fd58355061404f3089"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the filename that was last successfully opened. <br /></td></tr>
<tr class="separator:ad4e42b0d2b33c3fd58355061404f3089"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a413a76850671300b540b2b7814526b34"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#a413a76850671300b540b2b7814526b34">getReadPosition</a> () const </td></tr>
<tr class="memdesc:a413a76850671300b540b2b7814526b34"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the current read position.  <a href="#a413a76850671300b540b2b7814526b34">More...</a><br /></td></tr>
<tr class="separator:a413a76850671300b540b2b7814526b34"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a92f1429038e21bc85cac7f79e1f31446"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#a92f1429038e21bc85cac7f79e1f31446">getWritePosition</a> () const </td></tr>
<tr class="memdesc:a92f1429038e21bc85cac7f79e1f31446"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the current write position.  <a href="#a92f1429038e21bc85cac7f79e1f31446">More...</a><br /></td></tr>
<tr class="separator:a92f1429038e21bc85cac7f79e1f31446"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a59f23436f3af0beed89e8828dac38d9c"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#a59f23436f3af0beed89e8828dac38d9c">insertData</a> (<a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a> start, const <a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;data)</td></tr>
<tr class="memdesc:a59f23436f3af0beed89e8828dac38d9c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Insert the given data into the file.  <a href="#a59f23436f3af0beed89e8828dac38d9c">More...</a><br /></td></tr>
<tr class="separator:a59f23436f3af0beed89e8828dac38d9c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa6886b654f6ea50fc6c1a14a90c649ae"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#aa6886b654f6ea50fc6c1a14a90c649ae">isReadOnly</a> () const </td></tr>
<tr class="memdesc:aa6886b654f6ea50fc6c1a14a90c649ae"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return whether the file is read-only or not.  <a href="#aa6886b654f6ea50fc6c1a14a90c649ae">More...</a><br /></td></tr>
<tr class="separator:aa6886b654f6ea50fc6c1a14a90c649ae"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a27c1e4f7df5622942b03aa2ef5910d85"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#a27c1e4f7df5622942b03aa2ef5910d85">open</a> (const <a class="el" href="struct_xs_string.html">XsString</a> &amp;filename, bool createNew, bool readOnly)</td></tr>
<tr class="memdesc:a27c1e4f7df5622942b03aa2ef5910d85"><td class="mdescLeft">&#160;</td><td class="mdescRight">Open a file.  <a href="#a27c1e4f7df5622942b03aa2ef5910d85">More...</a><br /></td></tr>
<tr class="separator:a27c1e4f7df5622942b03aa2ef5910d85"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8c545a979c1025056b704d6776ac41d6"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#a8c545a979c1025056b704d6776ac41d6">setReadPosition</a> (<a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a> pos)</td></tr>
<tr class="memdesc:a8c545a979c1025056b704d6776ac41d6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the new absolute read position.  <a href="#a8c545a979c1025056b704d6776ac41d6">More...</a><br /></td></tr>
<tr class="separator:a8c545a979c1025056b704d6776ac41d6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9bc20dd4340a0550744775db8c794005"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#a9bc20dd4340a0550744775db8c794005">setWritePosition</a> (<a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a> pos=-1)</td></tr>
<tr class="memdesc:a9bc20dd4340a0550744775db8c794005"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the new absolute write position.  <a href="#a9bc20dd4340a0550744775db8c794005">More...</a><br /></td></tr>
<tr class="separator:a9bc20dd4340a0550744775db8c794005"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aadaff3109d61c4d3ec81e9a9281254e3"><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#aadaff3109d61c4d3ec81e9a9281254e3">reserve</a> (<a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a> minSize)</td></tr>
<tr class="memdesc:aadaff3109d61c4d3ec81e9a9281254e3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Make sure the file is at least <em>minSize</em> bytes big.  <a href="#aadaff3109d61c4d3ec81e9a9281254e3">More...</a><br /></td></tr>
<tr class="separator:aadaff3109d61c4d3ec81e9a9281254e3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_struct_io_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_struct_io_interface')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="struct_io_interface.html">IoInterface</a></td></tr>
<tr class="memitem:a738a8cb24aa12562b04c5067bd3d99b7 inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a738a8cb24aa12562b04c5067bd3d99b7"></a>
virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a738a8cb24aa12562b04c5067bd3d99b7">~IoInterface</a> ()</td></tr>
<tr class="memdesc:a738a8cb24aa12562b04c5067bd3d99b7 inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor. <br /></td></tr>
<tr class="separator:a738a8cb24aa12562b04c5067bd3d99b7 inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a567804b45988f0111362d600babd4627 inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a567804b45988f0111362d600babd4627">open</a> (const <a class="el" href="struct_xs_port_info.html">XsPortInfo</a> &amp;portInfo, uint32_t readBufSize=(XS_MAXMSGLEN *8), uint32_t writeBufSize=XS_MAXMSGLEN, <a class="el" href="struct_io_interface.html#a24230835a198e4af06866402ac41f22a">PortOptions</a> options=PO_XsensDefaults)</td></tr>
<tr class="memdesc:a567804b45988f0111362d600babd4627 inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Open a communication channel to the given port info.  <a href="#a567804b45988f0111362d600babd4627">More...</a><br /></td></tr>
<tr class="separator:a567804b45988f0111362d600babd4627 inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a895370317c9fde8cf199b9049bef48f0 inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a895370317c9fde8cf199b9049bef48f0">setTimeout</a> (uint32_t ms)</td></tr>
<tr class="memdesc:a895370317c9fde8cf199b9049bef48f0 inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the default timeout value to use in blocking operations.  <a href="#a895370317c9fde8cf199b9049bef48f0">More...</a><br /></td></tr>
<tr class="separator:a895370317c9fde8cf199b9049bef48f0 inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa9763f4a8ea90af8abeab4ada6f36502 inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#aa9763f4a8ea90af8abeab4ada6f36502">waitForData</a> (XsSize maxLength, <a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;data)</td></tr>
<tr class="memdesc:aa9763f4a8ea90af8abeab4ada6f36502 inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Wait for data to arrive or a timeout to occur.  <a href="#aa9763f4a8ea90af8abeab4ada6f36502">More...</a><br /></td></tr>
<tr class="separator:aa9763f4a8ea90af8abeab4ada6f36502 inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a030b6c12d92276a494fc926e578ada79 inherit pub_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a030b6c12d92276a494fc926e578ada79">cancelIo</a> (void) const </td></tr>
<tr class="memdesc:a030b6c12d92276a494fc926e578ada79 inherit pub_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Cancel any pending io requests.  <a href="#a030b6c12d92276a494fc926e578ada79">More...</a><br /></td></tr>
<tr class="separator:a030b6c12d92276a494fc926e578ada79 inherit pub_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:a94319925275c7f6d58e66be64526a37e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a94319925275c7f6d58e66be64526a37e"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#a94319925275c7f6d58e66be64526a37e">gotoRead</a> ()</td></tr>
<tr class="memdesc:a94319925275c7f6d58e66be64526a37e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Change from writing to reading mode. <br /></td></tr>
<tr class="separator:a94319925275c7f6d58e66be64526a37e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7c3188b07427b266ab223b8c2f41a25c"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a7c3188b07427b266ab223b8c2f41a25c"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#a7c3188b07427b266ab223b8c2f41a25c">gotoWrite</a> ()</td></tr>
<tr class="memdesc:a7c3188b07427b266ab223b8c2f41a25c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Change from reading to writing mode. <br /></td></tr>
<tr class="separator:a7c3188b07427b266ab223b8c2f41a25c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_methods_struct_io_interface"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_struct_io_interface')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="struct_io_interface.html">IoInterface</a></td></tr>
<tr class="memitem:a0a4be67f0496efa12593cc69a802d784 inherit pro_methods_struct_io_interface"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0a4be67f0496efa12593cc69a802d784"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a0a4be67f0496efa12593cc69a802d784">IoInterface</a> ()</td></tr>
<tr class="memdesc:a0a4be67f0496efa12593cc69a802d784 inherit pro_methods_struct_io_interface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor. <br /></td></tr>
<tr class="separator:a0a4be67f0496efa12593cc69a802d784 inherit pro_methods_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a6d851fcdec9e4faa67d87e3c58956b87"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a6d851fcdec9e4faa67d87e3c58956b87"></a>
<a class="el" href="struct_xs_file.html">XsFile</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#a6d851fcdec9e4faa67d87e3c58956b87">m_handle</a></td></tr>
<tr class="memdesc:a6d851fcdec9e4faa67d87e3c58956b87"><td class="mdescLeft">&#160;</td><td class="mdescRight">The file handle, also indicates if the file is open or not. <br /></td></tr>
<tr class="separator:a6d851fcdec9e4faa67d87e3c58956b87"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abb96531ce553f131a0ed19fc7068f221"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="abb96531ce553f131a0ed19fc7068f221"></a>
<a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#abb96531ce553f131a0ed19fc7068f221">m_fileSize</a></td></tr>
<tr class="memdesc:abb96531ce553f131a0ed19fc7068f221"><td class="mdescLeft">&#160;</td><td class="mdescRight">Contains the size of the file. <br /></td></tr>
<tr class="separator:abb96531ce553f131a0ed19fc7068f221"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abf3b0adfe8be7add27f23b4f4964c5ee"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="abf3b0adfe8be7add27f23b4f4964c5ee"></a>
<a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#abf3b0adfe8be7add27f23b4f4964c5ee">m_readPos</a></td></tr>
<tr class="memdesc:abf3b0adfe8be7add27f23b4f4964c5ee"><td class="mdescLeft">&#160;</td><td class="mdescRight">The last read position in the file. <br /></td></tr>
<tr class="separator:abf3b0adfe8be7add27f23b4f4964c5ee"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa658e2c6c3c8d3d405a66128300ea9ce"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa658e2c6c3c8d3d405a66128300ea9ce"></a>
<a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#aa658e2c6c3c8d3d405a66128300ea9ce">m_writePos</a></td></tr>
<tr class="memdesc:aa658e2c6c3c8d3d405a66128300ea9ce"><td class="mdescLeft">&#160;</td><td class="mdescRight">The last write position in the file. <br /></td></tr>
<tr class="separator:aa658e2c6c3c8d3d405a66128300ea9ce"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aae52c5f8f15304e904e9bb6e026d1dd1"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aae52c5f8f15304e904e9bb6e026d1dd1"></a>
<a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#aae52c5f8f15304e904e9bb6e026d1dd1">m_lastResult</a></td></tr>
<tr class="memdesc:aae52c5f8f15304e904e9bb6e026d1dd1"><td class="mdescLeft">&#160;</td><td class="mdescRight">The last result of an operation. <br /></td></tr>
<tr class="separator:aae52c5f8f15304e904e9bb6e026d1dd1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3880a4b104971070c98bc340e8df37b5"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a3880a4b104971070c98bc340e8df37b5"></a>
<a class="el" href="struct_xs_string.html">XsString</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#a3880a4b104971070c98bc340e8df37b5">m_filename</a></td></tr>
<tr class="memdesc:a3880a4b104971070c98bc340e8df37b5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Contains the name of the file that was last successfully opened. <br /></td></tr>
<tr class="separator:a3880a4b104971070c98bc340e8df37b5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a40fb87434680490406d1c1e6e463bf14"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#a40fb87434680490406d1c1e6e463bf14">m_reading</a></td></tr>
<tr class="memdesc:a40fb87434680490406d1c1e6e463bf14"><td class="mdescLeft">&#160;</td><td class="mdescRight">Indicates whether the last operation was a read or write operation.  <a href="#a40fb87434680490406d1c1e6e463bf14">More...</a><br /></td></tr>
<tr class="separator:a40fb87434680490406d1c1e6e463bf14"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acbc2022d183845a7f9868310a09a7838"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="acbc2022d183845a7f9868310a09a7838"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_io_interface_file.html#acbc2022d183845a7f9868310a09a7838">m_readOnly</a></td></tr>
<tr class="memdesc:acbc2022d183845a7f9868310a09a7838"><td class="mdescLeft">&#160;</td><td class="mdescRight">Indicates if the file was opened in read-only mode. <br /></td></tr>
<tr class="separator:acbc2022d183845a7f9868310a09a7838"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pub_types_struct_io_interface"><td colspan="2" onclick="javascript:toggleInherit('pub_types_struct_io_interface')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="struct_io_interface.html">IoInterface</a></td></tr>
<tr class="memitem:a24230835a198e4af06866402ac41f22a inherit pub_types_struct_io_interface"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a24230835a198e4af06866402ac41f22a"></a>enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="struct_io_interface.html#a24230835a198e4af06866402ac41f22a">PortOptions</a> { <br />
&#160;&#160;<b>PO_NoFlowControl</b> = 0, 
<b>PO_RtsCtsFlowControl</b> = (1 &lt;&lt; 0), 
<b>PO_DtrDsrFlowControl</b> = (1 &lt;&lt; 1), 
<b>PO_XonXoffFlowControl</b> = (1 &lt;&lt; 2), 
<br />
&#160;&#160;<b>PO_OneStopBit</b> = 0, 
<b>PO_TwoStopBits</b> = (1 &lt;&lt; 3), 
<b>PO_XsensDefaults</b> = (PO_NoFlowControl|PO_TwoStopBits)
<br />
 }<tr class="memdesc:a24230835a198e4af06866402ac41f22a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Options for flow control and stopbits which must be used when opening a port. <br /></td></tr>
</td></tr>
<tr class="separator:a24230835a198e4af06866402ac41f22a inherit pub_types_struct_io_interface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>The low-level file communication class. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="afe61a877361812e624a4dd8b4fb60fa2"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">IoInterfaceFile::IoInterfaceFile </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Default constructor, initializes all members to their default values. </p>

</div>
</div>
<a class="anchor" id="aa0fae8ef051e708aa3658add2808c780"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">IoInterfaceFile::~IoInterfaceFile </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Destructor </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a02f006131b80872d2425b0cc9fad445f"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> IoInterfaceFile::appendData </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;&#160;</td>
          <td class="paramname"><em>bdata</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Write data to the end of the file. </p>
<p>The function writes the given data to the file at the end. The current write position is also moved to the end of the file. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">bdata</td><td>The byte data to append to the file </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if the write was successful </dd></dl>

<p>Reimplemented from <a class="el" href="struct_io_interface.html#ae4f4b165b49c75cb28bc1e4fffaf533d">IoInterface</a>.</p>

</div>
</div>
<a class="anchor" id="a83fce965ce5bc30b9f8e58057d9abc7c"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> IoInterfaceFile::close </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Close the file, overrides <a class="el" href="struct_io_interface.html#a3256915d0f4056dec116d500c9c2382c" title="Close the connection to the device. ">IoInterface::close()</a>. </p>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if the file was closed successfully </dd></dl>

<p>Implements <a class="el" href="struct_io_interface.html#a3256915d0f4056dec116d500c9c2382c">IoInterface</a>.</p>

</div>
</div>
<a class="anchor" id="a1856f74bcaf06c2e826237b68fa6d781"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> IoInterfaceFile::closeAndDelete </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Close the file and delete it. </p>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if the file was closed and deleted successfully </dd></dl>

<p>Reimplemented from <a class="el" href="struct_io_interface.html#a108ea51f7057bc5f762052777e7baa00">IoInterface</a>.</p>

</div>
</div>
<a class="anchor" id="ac740d713c17c0635271b26d2decc7383"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> IoInterfaceFile::closeFile </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Close the file. </p>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if the file was closed successfully </dd></dl>

</div>
</div>
<a class="anchor" id="a90ebe248517cdd233e270704a4a51c8e"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> IoInterfaceFile::create </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="struct_xs_string.html">XsString</a> &amp;&#160;</td>
          <td class="paramname"><em>filename</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Create an empty file. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">filename</td><td>The desired (path+)name of the file </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if the file was created successfully </dd></dl>

<p>Reimplemented from <a class="el" href="struct_io_interface.html#a3e82060ef66d73b95b383f75867f3e0f">IoInterface</a>.</p>

</div>
</div>
<a class="anchor" id="a1073cd5d38d4590e0e2953af7f5f8c44"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> IoInterfaceFile::deleteData </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a>&#160;</td>
          <td class="paramname"><em>start</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">XsSize&#160;</td>
          <td class="paramname"><em>length</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Delete the given data from the file. </p>
<p>The function erases the given data from the file at the given write position. This operation may take a while to complete, but is faster than insertData.</p>
<p>The write position is not changed and the read position is checked for validity upon function exit. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">start</td><td>The offset of the first byte to delete </td></tr>
    <tr><td class="paramname">length</td><td>The total number of bytes to delete </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if the data was deleted successfully </dd></dl>

<p>Reimplemented from <a class="el" href="struct_io_interface.html#a5c4a40c13cdd1dbd36da1323f8d8236c">IoInterface</a>.</p>

</div>
</div>
<a class="anchor" id="ac238d2c4d69f981009b0db4bf9fbb9f2"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> IoInterfaceFile::find </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;&#160;</td>
          <td class="paramname"><em>needleV</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a> &amp;&#160;</td>
          <td class="paramname"><em>pos</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Find a string of bytes in the file. </p>
<p>The function searches from the current read position until the given <code>needle</code> is found. If the needle is not found, XsResultValue::NOT_FOUND is returned. The function will update the seek position to the first character of the found needle. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">needleV</td><td>The byte string to find. </td></tr>
    <tr><td class="paramname">pos</td><td>The position where <em>needleV</em> was found. This will point to the first character of the found <em>needleV</em>. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if the data was found, XRV_ENDOFFILE if it wasn't found </dd></dl>

<p>Reimplemented from <a class="el" href="struct_io_interface.html#a6256ce5c2def7b6f6961cedd8199e35e">IoInterface</a>.</p>

</div>
</div>
<a class="anchor" id="aecc40c56361c0cf28e70545d6cc78ca2"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> IoInterfaceFile::flushData </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Flush all data in the buffers to and from the device. </p>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if the data was flushed successfully </dd></dl>

<p>Implements <a class="el" href="struct_io_interface.html#aac5cc2c3707b24cc15f9ab15914448fa">IoInterface</a>.</p>

</div>
</div>
<a class="anchor" id="a28c28fbac8993d2eeea459ed0f3ddc90"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="struct_xs_time_stamp.html">XsTimeStamp</a> IoInterfaceFile::getFileDate </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Return the creation date of the file. </p>
<dl class="section return"><dt>Returns</dt><dd>The creation date of the file </dd></dl>

</div>
</div>
<a class="anchor" id="afd93d17ccecb4859a08569d10692db94"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a> IoInterfaceFile::getFileSize </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Return the size of the file. </p>
<dl class="section return"><dt>Returns</dt><dd>The size of the file. </dd></dl>

<p>Reimplemented from <a class="el" href="struct_io_interface.html#af7acf94e2070b556290d969a324e8b93">IoInterface</a>.</p>

</div>
</div>
<a class="anchor" id="aa3eaa5e537ea2cc4c8d9d81c9b705955"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> IoInterfaceFile::getLastResult </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Return the result code of the last operation. </p>
<dl class="section return"><dt>Returns</dt><dd>The result code of the last operation. </dd></dl>

<p>Implements <a class="el" href="struct_io_interface.html#af675487959bd1961e7ca815e4abcebee">IoInterface</a>.</p>

</div>
</div>
<a class="anchor" id="a809280e635cbdb2a928577f706ac95af"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> IoInterfaceFile::getName </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="struct_xs_string.html">XsString</a> &amp;&#160;</td>
          <td class="paramname"><em>filename</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Retrieve the filename that was last successfully opened. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">filename</td><td>The <a class="el" href="struct_xs_string.html" title="A 0-terminated managed string of characters. ">XsString</a> which will contain the filename. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK </dd></dl>

<p>Reimplemented from <a class="el" href="struct_io_interface.html#a7bbdfbb5caad826f6e6d81a73940fd0d">IoInterface</a>.</p>

</div>
</div>
<a class="anchor" id="a413a76850671300b540b2b7814526b34"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a> IoInterfaceFile::getReadPosition </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Return the current read position. </p>
<dl class="section return"><dt>Returns</dt><dd>The current read position. </dd></dl>

<p>Reimplemented from <a class="el" href="struct_io_interface.html#a396d5028db152401dd83cfe8f0b6977e">IoInterface</a>.</p>

</div>
</div>
<a class="anchor" id="a92f1429038e21bc85cac7f79e1f31446"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a> IoInterfaceFile::getWritePosition </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Return the current write position. </p>
<dl class="section return"><dt>Returns</dt><dd>The current write position. </dd></dl>

<p>Reimplemented from <a class="el" href="struct_io_interface.html#a6ce051fb4db1dbace80bb0545b9cd343">IoInterface</a>.</p>

</div>
</div>
<a class="anchor" id="a59f23436f3af0beed89e8828dac38d9c"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> IoInterfaceFile::insertData </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a>&#160;</td>
          <td class="paramname"><em>start</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;&#160;</td>
          <td class="paramname"><em>data</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Insert the given data into the file. </p>
<p>The function writes the given data to the file at the current write position. This operation may take a while to complete.</p>
<p>The write position is placed at the end of the inserted data. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">start</td><td>The offset in the file to write the first byte </td></tr>
    <tr><td class="paramname">data</td><td>The data to insert in the file </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if the data was inserted successfully </dd></dl>

<p>Reimplemented from <a class="el" href="struct_io_interface.html#ad0d5e78791e017e06f8beaa6561bd844">IoInterface</a>.</p>

</div>
</div>
<a class="anchor" id="ab66936abe77dc38fd58da68c984ad60d"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool IoInterfaceFile::isOpen </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Return whether the file is open or not. </p>
<dl class="section return"><dt>Returns</dt><dd>true if the file is open </dd></dl>

<p>Implements <a class="el" href="struct_io_interface.html#a576dc64a3aa88825d7da4e38361c9864">IoInterface</a>.</p>

</div>
</div>
<a class="anchor" id="aa6886b654f6ea50fc6c1a14a90c649ae"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool IoInterfaceFile::isReadOnly </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Return whether the file is read-only or not. </p>
<dl class="section return"><dt>Returns</dt><dd>true if the file is read-only </dd></dl>

<p>Reimplemented from <a class="el" href="struct_io_interface.html#a905628de220b542bdfbf3692a55de428">IoInterface</a>.</p>

</div>
</div>
<a class="anchor" id="a27c1e4f7df5622942b03aa2ef5910d85"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> IoInterfaceFile::open </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="struct_xs_string.html">XsString</a> &amp;&#160;</td>
          <td class="paramname"><em>filename</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>createNew</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>readOnly</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Open a file. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">filename</td><td>The name of the file to open </td></tr>
    <tr><td class="paramname">createNew</td><td>When true, the file will be created if it doesn't exist yet </td></tr>
    <tr><td class="paramname">readOnly</td><td>When true, the file will be marked as read only for IoInterfaceFile, preventing accidental writes to the file. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if the file was opened successfully </dd></dl>
<dl class="section see"><dt>See also</dt><dd>createFile </dd></dl>

<p>Reimplemented from <a class="el" href="struct_io_interface.html#a041ed4c0878f91fa8c41a72aa7b3e802">IoInterface</a>.</p>

</div>
</div>
<a class="anchor" id="a2d4e1496bc2c478c726f297e8dd078c7"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> IoInterfaceFile::readData </td>
          <td>(</td>
          <td class="paramtype">XsSize&#160;</td>
          <td class="paramname"><em>maxLength</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;&#160;</td>
          <td class="paramname"><em>data</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Read at most <em>maxLength</em> bytes from the device into <em>data</em>. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">maxLength</td><td>The maximum number of bytes to read. Depending on the device type and timeout settings, the function may return with less than this number of bytes read. </td></tr>
    <tr><td class="paramname">data</td><td>A buffer that will contain the read data. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if all data was read successfully, XRV_TIMEOUT if some data was read, but not <em>maxLength</em>, XRV_TIMEOUTNODATA if no data was read at all. </dd></dl>
<dl class="section note"><dt>Note</dt><dd>This function reads exactly the number of bytes as requested from the file unless the end of file boundary is encountered. </dd></dl>

<p>Implements <a class="el" href="struct_io_interface.html#a33818cfaffd39a7e1382e465d26efc0a">IoInterface</a>.</p>

</div>
</div>
<a class="anchor" id="ade44b56b10040f5cb6e6b97a17076c19"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> IoInterfaceFile::readTerminatedData </td>
          <td>(</td>
          <td class="paramtype">XsSize&#160;</td>
          <td class="paramname"><em>maxLength</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned char&#160;</td>
          <td class="paramname"><em>terminator</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;&#160;</td>
          <td class="paramname"><em>bdata</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Read data from the file and put it into the data buffer. </p>
<p>This function reads up to the number of bytes as requested from the file. The function will also stop if the given terminator character is encountered. The terminator is included in the output buffer. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">maxLength</td><td>The amount of data that will be read. </td></tr>
    <tr><td class="paramname">terminator</td><td>A character that will end the read operation if encountered. </td></tr>
    <tr><td class="paramname">bdata</td><td>A buffer that will store the read data. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if the data was read successfully </dd></dl>

</div>
</div>
<a class="anchor" id="aadaff3109d61c4d3ec81e9a9281254e3"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> IoInterfaceFile::reserve </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a>&#160;</td>
          <td class="paramname"><em>minSize</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Make sure the file is at least <em>minSize</em> bytes big. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">minSize</td><td>The minimum file size required </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if the reserve succeeded</dd></dl>
<p>The file will not be truncated, any added bytes will be filled with '\0' characters </p>

</div>
</div>
<a class="anchor" id="a8c545a979c1025056b704d6776ac41d6"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> IoInterfaceFile::setReadPosition </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a>&#160;</td>
          <td class="paramname"><em>pos</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Set the new absolute read position. </p>
<p>The read position is checked against the file size first. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">pos</td><td>The new read position </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if the read position was updated successfully </dd></dl>

<p>Reimplemented from <a class="el" href="struct_io_interface.html#a6e75151a26492f0fa9666edabc09d817">IoInterface</a>.</p>

</div>
</div>
<a class="anchor" id="a9bc20dd4340a0550744775db8c794005"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> IoInterfaceFile::setWritePosition </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__cinterface.html#gaee1db0cf1b8591c59afba7a3a0d13eb9">XsFilePos</a>&#160;</td>
          <td class="paramname"><em>pos</em> = <code>-1</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Set the new absolute write position. </p>
<p>The write position is checked against the file size first. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">pos</td><td>The new write position </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if the write position was updated successfully </dd></dl>

<p>Reimplemented from <a class="el" href="struct_io_interface.html#a115109da1f9f05a36222f00cd569cd52">IoInterface</a>.</p>

</div>
</div>
<a class="anchor" id="a358b75e4c84de5e7fc533033c21b4c79"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__enums.html#ga31f1629126181b5371b3f3aff1b3bb72">XsResultValue</a> IoInterfaceFile::writeData </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="struct_xs_byte_array.html">XsByteArray</a> &amp;&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">XsSize *&#160;</td>
          <td class="paramname"><em>written</em> = <code>nullptr</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Write the data contained in <em>data</em> to the device. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">data</td><td>The data to write to the device. </td></tr>
    <tr><td class="paramname">written</td><td>An optional XsSize value that will receive the number of bytes that were actually written. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>XRV_OK if the data was written successfully </dd></dl>
<dl class="section note"><dt>Note</dt><dd>The function writes the given data to the file at the current write position. </dd></dl>

<p>Implements <a class="el" href="struct_io_interface.html#a8e8f067dac101d2ef49080956ad53970">IoInterface</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a class="anchor" id="a40fb87434680490406d1c1e6e463bf14"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool IoInterfaceFile::m_reading</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Indicates whether the last operation was a read or write operation. </p>
<p>This value is used to check whether or not a seek is required to perform a requested read or write operation. </p>

</div>
</div>
</div><!-- contents -->

<div class="tabs">&nbsp;</div>
<hr size="1" />
<address style="text-align: right;">
<small>Generated on Wed May 17 2017 for Xsens by <a href="http://www.doxygen.org/index.html">Doxygen</a> 1.8.11</small>
</address>
</body>
</html>
